diff --git a/src/formats.c b/src/formats.c
index 7323428ffc..ba350f18e9 100644
--- a/src/formats.c
+++ b/src/formats.c
@@ -1486,7 +1486,9 @@ static void test_fmt_split_unifies_case_4(struct fmt_main *format, char *ciphert
 						good = 1;
 					if (!good) {
 						// white list.
-						if (!strncmp(ret, "@dynamic=", 9)) {
+						if (!strncmp(ret, "@dynamic=", 9) ||
+						    (ret[0]=='$'&&ret[1]=='2'&&ret[3]=='$'&& (ret[2]=='a'||ret[2]=='b'||ret[2]=='x'||ret[2]=='y') ) )
+						{
 						} else
 							goto change_case;
 					}
@@ -1569,6 +1571,8 @@ char *fmt_self_test(struct fmt_main *format, struct db_main *db)
 	 * while self-test is running. */
 	bench_running = 1;
 
+	if (benchmark_level >= 0)
+		benchmark_time = 0;
 	retval = fmt_self_test_body(format, binary_copy, salt_copy, db, benchmark_level);
 
 	bench_running = 0;
diff --git a/src/rar_common.c b/src/rar_common.c
index 598bd393a8..74932c88f3 100644
--- a/src/rar_common.c
+++ b/src/rar_common.c
@@ -303,12 +303,12 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto error;
 	if (!(ptr = strtokm(NULL, "*"))) /* salt */
 		goto error;
-	if (hexlen(ptr) != 16) /* 8 bytes of salt */
+	if (hexlenl(ptr) != 16) /* 8 bytes of salt */
 		goto error;
 	if (!(ptr = strtokm(NULL, "*")))
 		goto error;
 	if (mode == 0) {
-		if (hexlen(ptr) != 32) /* 16 bytes of encrypted known plain */
+		if (hexlenl(ptr) != 32) /* 16 bytes of encrypted known plain */
 			goto error;
 		MEM_FREE(keeptr);
 		return 1;
@@ -316,7 +316,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		int inlined;
 		long long plen, ulen;
 
-		if (hexlen(ptr) != 8) /* 4 bytes of CRC */
+		if (hexlenl(ptr) != 8) /* 4 bytes of CRC */
 			goto error;
 		if (!(ptr = strtokm(NULL, "*"))) /* pack_size */
 			goto error;
@@ -352,7 +352,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		if (!(ptr = strtokm(NULL, "*"))) /* pack_size / archive_name */
 			goto error;
 		if (inlined) {
-			if (hexlen(ptr) != plen * 2)
+			if (hexlenl(ptr) != plen * 2)
 				goto error;
 		} else {
 			FILE *fp;
